/// Request to list the dataset files backing a video channel series.
/// Uses channel + tags to resolve to video series metadata. Bounds are optional; when omitted
/// all dataset files for the channel are returned.
#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash
)]
#[serde(crate = "conjure_object::serde")]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct ListVideoChannelDatasetFilesRequest {
    #[builder(custom(type = super::VideoChannelSeries, convert = Box::new))]
    #[serde(rename = "channelSeries")]
    channel_series: Box<super::VideoChannelSeries>,
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::Bounds>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(rename = "bounds", skip_serializing_if = "Option::is_none", default)]
    bounds: Option<Box<super::Bounds>>,
    #[builder(default, into)]
    #[serde(rename = "pageSize", skip_serializing_if = "Option::is_none", default)]
    page_size: Option<i32>,
    #[builder(default, into)]
    #[serde(rename = "token", skip_serializing_if = "Option::is_none", default)]
    token: Option<String>,
}
impl ListVideoChannelDatasetFilesRequest {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new(channel_series: super::VideoChannelSeries) -> Self {
        Self::builder().channel_series(channel_series).build()
    }
    #[inline]
    pub fn channel_series(&self) -> &super::VideoChannelSeries {
        &*self.channel_series
    }
    #[inline]
    pub fn bounds(&self) -> Option<&super::Bounds> {
        self.bounds.as_ref().map(|o| &**o)
    }
    /// Defaults to 100. Will throw if larger than 1_000.
    #[inline]
    pub fn page_size(&self) -> Option<i32> {
        self.page_size.as_ref().map(|o| *o)
    }
    #[inline]
    pub fn token(&self) -> Option<&str> {
        self.token.as_ref().map(|o| &**o)
    }
}
